git-clone.shon commit Merge branch 'sp/mergetool' (6959893)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, Linus Torvalds
   4# Copyright (c) 2005, Junio C Hamano
   5#
   6# Clone a repository into a different directory that does not yet exist.
   7
   8# See git-sh-setup why.
   9unset CDPATH
  10
  11die() {
  12        echo >&2 "$@"
  13        exit 1
  14}
  15
  16usage() {
  17        die "Usage: $0 [--template=<template_directory>] [--reference <reference-repo>] [--bare] [-l [-s]] [-q] [-u <upload-pack>] [--origin <name>] [--depth <n>] [-n] <repo> [<dir>]"
  18}
  19
  20get_repo_base() {
  21        (
  22                cd "`/bin/pwd`" &&
  23                cd "$1" || cd "$1.git" &&
  24                {
  25                        cd .git
  26                        pwd
  27                }
  28        ) 2>/dev/null
  29}
  30
  31if [ -n "$GIT_SSL_NO_VERIFY" -o \
  32        "`git config --bool http.sslVerify`" = false ]; then
  33    curl_extra_args="-k"
  34fi
  35
  36http_fetch () {
  37        # $1 = Remote, $2 = Local
  38        curl -nsfL $curl_extra_args "$1" >"$2" ||
  39                case $? in
  40                126|127) exit ;;
  41                *)       return $? ;;
  42                esac
  43}
  44
  45clone_dumb_http () {
  46        # $1 - remote, $2 - local
  47        cd "$2" &&
  48        clone_tmp="$GIT_DIR/clone-tmp" &&
  49        mkdir -p "$clone_tmp" || exit 1
  50        if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
  51                "`git config --bool http.noEPSV`" = true ]; then
  52                curl_extra_args="${curl_extra_args} --disable-epsv"
  53        fi
  54        http_fetch "$1/info/refs" "$clone_tmp/refs" ||
  55                die "Cannot get remote repository information.
  56Perhaps git-update-server-info needs to be run there?"
  57        test "z$quiet" = z && v=-v || v=
  58        while read sha1 refname
  59        do
  60                name=`expr "z$refname" : 'zrefs/\(.*\)'` &&
  61                case "$name" in
  62                *^*)    continue;;
  63                esac
  64                case "$bare,$name" in
  65                yes,* | ,heads/* | ,tags/*) ;;
  66                *)      continue ;;
  67                esac
  68                if test -n "$use_separate_remote" &&
  69                   branch_name=`expr "z$name" : 'zheads/\(.*\)'`
  70                then
  71                        tname="remotes/$origin/$branch_name"
  72                else
  73                        tname=$name
  74                fi
  75                git-http-fetch $v -a -w "$tname" "$sha1" "$1" || exit 1
  76        done <"$clone_tmp/refs"
  77        rm -fr "$clone_tmp"
  78        http_fetch "$1/HEAD" "$GIT_DIR/REMOTE_HEAD" ||
  79        rm -f "$GIT_DIR/REMOTE_HEAD"
  80        if test -f "$GIT_DIR/REMOTE_HEAD"; then
  81                head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
  82                case "$head_sha1" in
  83                'ref: refs/'*)
  84                        ;;
  85                *)
  86                        git-http-fetch $v -a "$head_sha1" "$1" ||
  87                        rm -f "$GIT_DIR/REMOTE_HEAD"
  88                        ;;
  89                esac
  90        fi
  91}
  92
  93quiet=
  94local=no
  95use_local_hardlink=yes
  96local_shared=no
  97unset template
  98no_checkout=
  99upload_pack=
 100bare=
 101reference=
 102origin=
 103origin_override=
 104use_separate_remote=t
 105depth=
 106no_progress=
 107local_explicitly_asked_for=
 108test -t 1 || no_progress=--no-progress
 109while
 110        case "$#,$1" in
 111        0,*) break ;;
 112        *,-n|*,--no|*,--no-|*,--no-c|*,--no-ch|*,--no-che|*,--no-chec|\
 113        *,--no-check|*,--no-checko|*,--no-checkou|*,--no-checkout)
 114          no_checkout=yes ;;
 115        *,--na|*,--nak|*,--nake|*,--naked|\
 116        *,-b|*,--b|*,--ba|*,--bar|*,--bare) bare=yes ;;
 117        *,-l|*,--l|*,--lo|*,--loc|*,--loca|*,--local)
 118          local_explicitly_asked_for=yes
 119          use_local_hardlink=yes ;;
 120        *,--no-h|*,--no-ha|*,--no-har|*,--no-hard|*,--no-hardl|\
 121        *,--no-hardli|*,--no-hardlin|*,--no-hardlink|*,--no-hardlinks)
 122          use_local_hardlink=no ;;
 123        *,-s|*,--s|*,--sh|*,--sha|*,--shar|*,--share|*,--shared)
 124          local_shared=yes; ;;
 125        1,--template) usage ;;
 126        *,--template)
 127                shift; template="--template=$1" ;;
 128        *,--template=*)
 129          template="$1" ;;
 130        *,-q|*,--quiet) quiet=-q ;;
 131        *,--use-separate-remote) ;;
 132        *,--no-separate-remote)
 133                die "clones are always made with separate-remote layout" ;;
 134        1,--reference) usage ;;
 135        *,--reference)
 136                shift; reference="$1" ;;
 137        *,--reference=*)
 138                reference=`expr "z$1" : 'z--reference=\(.*\)'` ;;
 139        *,-o|*,--or|*,--ori|*,--orig|*,--origi|*,--origin)
 140                case "$2" in
 141                '')
 142                    usage ;;
 143                */*)
 144                    die "'$2' is not suitable for an origin name"
 145                esac
 146                git check-ref-format "heads/$2" ||
 147                    die "'$2' is not suitable for a branch name"
 148                test -z "$origin_override" ||
 149                    die "Do not give more than one --origin options."
 150                origin_override=yes
 151                origin="$2"; shift
 152                ;;
 153        1,-u|1,--upload-pack) usage ;;
 154        *,-u|*,--upload-pack)
 155                shift
 156                upload_pack="--upload-pack=$1" ;;
 157        *,--upload-pack=*)
 158                upload_pack=--upload-pack=$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
 159        1,--depth) usage;;
 160        *,--depth)
 161                shift
 162                depth="--depth=$1";;
 163        *,-*) usage ;;
 164        *) break ;;
 165        esac
 166do
 167        shift
 168done
 169
 170repo="$1"
 171test -n "$repo" ||
 172    die 'you must specify a repository to clone.'
 173
 174# --bare implies --no-checkout and --no-separate-remote
 175if test yes = "$bare"
 176then
 177        if test yes = "$origin_override"
 178        then
 179                die '--bare and --origin $origin options are incompatible.'
 180        fi
 181        no_checkout=yes
 182        use_separate_remote=
 183fi
 184
 185if test -z "$origin"
 186then
 187        origin=origin
 188fi
 189
 190# Turn the source into an absolute path if
 191# it is local
 192if base=$(get_repo_base "$repo"); then
 193        repo="$base"
 194        local=yes
 195fi
 196
 197dir="$2"
 198# Try using "humanish" part of source repo if user didn't specify one
 199[ -z "$dir" ] && dir=$(echo "$repo" | sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
 200[ -e "$dir" ] && die "destination directory '$dir' already exists."
 201[ yes = "$bare" ] && unset GIT_WORK_TREE
 202[ -n "$GIT_WORK_TREE" ] && [ -e "$GIT_WORK_TREE" ] &&
 203die "working tree '$GIT_WORK_TREE' already exists."
 204D=
 205W=
 206cleanup() {
 207        err=$?
 208        test -z "$D" && rm -rf "$dir"
 209        test -z "$W" && test -n "$GIT_WORK_TREE" && rm -rf "$GIT_WORK_TREE"
 210        cd ..
 211        test -n "$D" && rm -rf "$D"
 212        test -n "$W" && rm -rf "$W"
 213        exit $err
 214}
 215trap cleanup 0
 216mkdir -p "$dir" && D=$(cd "$dir" && pwd) || usage
 217test -n "$GIT_WORK_TREE" && mkdir -p "$GIT_WORK_TREE" &&
 218W=$(cd "$GIT_WORK_TREE" && pwd) && export GIT_WORK_TREE="$W"
 219if test yes = "$bare" || test -n "$GIT_WORK_TREE"; then
 220        GIT_DIR="$D"
 221else
 222        GIT_DIR="$D/.git"
 223fi &&
 224export GIT_DIR &&
 225GIT_CONFIG="$GIT_DIR/config" git-init $quiet ${template+"$template"} || usage
 226
 227if test -n "$bare"
 228then
 229        GIT_CONFIG="$GIT_DIR/config" git config core.bare true
 230fi
 231
 232if test -n "$reference"
 233then
 234        ref_git=
 235        if test -d "$reference"
 236        then
 237                if test -d "$reference/.git/objects"
 238                then
 239                        ref_git="$reference/.git"
 240                elif test -d "$reference/objects"
 241                then
 242                        ref_git="$reference"
 243                fi
 244        fi
 245        if test -n "$ref_git"
 246        then
 247                ref_git=$(cd "$ref_git" && pwd)
 248                echo "$ref_git/objects" >"$GIT_DIR/objects/info/alternates"
 249                (
 250                        GIT_DIR="$ref_git" git for-each-ref \
 251                                --format='%(objectname) %(*objectname)'
 252                ) |
 253                while read a b
 254                do
 255                        test -z "$a" ||
 256                        git update-ref "refs/reference-tmp/$a" "$a"
 257                        test -z "$b" ||
 258                        git update-ref "refs/reference-tmp/$b" "$b"
 259                done
 260        else
 261                die "reference repository '$reference' is not a local directory."
 262        fi
 263fi
 264
 265rm -f "$GIT_DIR/CLONE_HEAD"
 266
 267# We do local magic only when the user tells us to.
 268case "$local" in
 269yes)
 270        ( cd "$repo/objects" ) ||
 271                die "cannot chdir to local '$repo/objects'."
 272
 273        if test "$local_shared" = yes
 274        then
 275                mkdir -p "$GIT_DIR/objects/info"
 276                echo "$repo/objects" >>"$GIT_DIR/objects/info/alternates"
 277        else
 278                l= &&
 279                if test "$use_local_hardlink" = yes
 280                then
 281                        # See if we can hardlink and drop "l" if not.
 282                        sample_file=$(cd "$repo" && \
 283                                      find objects -type f -print | sed -e 1q)
 284                        # objects directory should not be empty because
 285                        # we are cloning!
 286                        test -f "$repo/$sample_file" || exit
 287                        if ln "$repo/$sample_file" "$GIT_DIR/objects/sample" 2>/dev/null
 288                        then
 289                                rm -f "$GIT_DIR/objects/sample"
 290                                l=l
 291                        elif test -n "$local_explicitly_asked_for"
 292                        then
 293                                echo >&2 "Warning: -l asked but cannot hardlink to $repo"
 294                        fi
 295                fi &&
 296                cd "$repo" &&
 297                find objects -depth -print | cpio -pumd$l "$GIT_DIR/" || exit 1
 298        fi
 299        git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
 300        ;;
 301*)
 302        case "$repo" in
 303        rsync://*)
 304                case "$depth" in
 305                "") ;;
 306                *) die "shallow over rsync not supported" ;;
 307                esac
 308                rsync $quiet -av --ignore-existing  \
 309                        --exclude info "$repo/objects/" "$GIT_DIR/objects/" ||
 310                exit
 311                # Look at objects/info/alternates for rsync -- http will
 312                # support it natively and git native ones will do it on the
 313                # remote end.  Not having that file is not a crime.
 314                rsync -q "$repo/objects/info/alternates" \
 315                        "$GIT_DIR/TMP_ALT" 2>/dev/null ||
 316                        rm -f "$GIT_DIR/TMP_ALT"
 317                if test -f "$GIT_DIR/TMP_ALT"
 318                then
 319                    ( cd "$D" &&
 320                      . git-parse-remote &&
 321                      resolve_alternates "$repo" <"$GIT_DIR/TMP_ALT" ) |
 322                    while read alt
 323                    do
 324                        case "$alt" in 'bad alternate: '*) die "$alt";; esac
 325                        case "$quiet" in
 326                        '')     echo >&2 "Getting alternate: $alt" ;;
 327                        esac
 328                        rsync $quiet -av --ignore-existing  \
 329                            --exclude info "$alt" "$GIT_DIR/objects" || exit
 330                    done
 331                    rm -f "$GIT_DIR/TMP_ALT"
 332                fi
 333                git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
 334                ;;
 335        https://*|http://*|ftp://*)
 336                case "$depth" in
 337                "") ;;
 338                *) die "shallow over http or ftp not supported" ;;
 339                esac
 340                if test -z "@@NO_CURL@@"
 341                then
 342                        clone_dumb_http "$repo" "$D"
 343                else
 344                        die "http transport not supported, rebuild Git with curl support"
 345                fi
 346                ;;
 347        *)
 348                case "$upload_pack" in
 349                '') git-fetch-pack --all -k $quiet $depth $no_progress "$repo";;
 350                *) git-fetch-pack --all -k $quiet "$upload_pack" $depth $no_progress "$repo" ;;
 351                esac >"$GIT_DIR/CLONE_HEAD" ||
 352                        die "fetch-pack from '$repo' failed."
 353                ;;
 354        esac
 355        ;;
 356esac
 357test -d "$GIT_DIR/refs/reference-tmp" && rm -fr "$GIT_DIR/refs/reference-tmp"
 358
 359if test -f "$GIT_DIR/CLONE_HEAD"
 360then
 361        # Read git-fetch-pack -k output and store the remote branches.
 362        if [ -n "$use_separate_remote" ]
 363        then
 364                branch_top="remotes/$origin"
 365        else
 366                branch_top="heads"
 367        fi
 368        tag_top="tags"
 369        while read sha1 name
 370        do
 371                case "$name" in
 372                *'^{}')
 373                        continue ;;
 374                HEAD)
 375                        destname="REMOTE_HEAD" ;;
 376                refs/heads/*)
 377                        destname="refs/$branch_top/${name#refs/heads/}" ;;
 378                refs/tags/*)
 379                        destname="refs/$tag_top/${name#refs/tags/}" ;;
 380                *)
 381                        continue ;;
 382                esac
 383                git update-ref -m "clone: from $repo" "$destname" "$sha1" ""
 384        done < "$GIT_DIR/CLONE_HEAD"
 385fi
 386
 387if test -n "$W"; then
 388        cd "$W" || exit
 389else
 390        cd "$D" || exit
 391fi
 392
 393if test -z "$bare" && test -f "$GIT_DIR/REMOTE_HEAD"
 394then
 395        # a non-bare repository is always in separate-remote layout
 396        remote_top="refs/remotes/$origin"
 397        head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
 398        case "$head_sha1" in
 399        'ref: refs/'*)
 400                # Uh-oh, the remote told us (http transport done against
 401                # new style repository with a symref HEAD).
 402                # Ideally we should skip the guesswork but for now
 403                # opt for minimum change.
 404                head_sha1=`expr "z$head_sha1" : 'zref: refs/heads/\(.*\)'`
 405                head_sha1=`cat "$GIT_DIR/$remote_top/$head_sha1"`
 406                ;;
 407        esac
 408
 409        # The name under $remote_top the remote HEAD seems to point at.
 410        head_points_at=$(
 411                (
 412                        test -f "$GIT_DIR/$remote_top/master" && echo "master"
 413                        cd "$GIT_DIR/$remote_top" &&
 414                        find . -type f -print | sed -e 's/^\.\///'
 415                ) | (
 416                done=f
 417                while read name
 418                do
 419                        test t = $done && continue
 420                        branch_tip=`cat "$GIT_DIR/$remote_top/$name"`
 421                        if test "$head_sha1" = "$branch_tip"
 422                        then
 423                                echo "$name"
 424                                done=t
 425                        fi
 426                done
 427                )
 428        )
 429
 430        # Upstream URL
 431        git config remote."$origin".url "$repo" &&
 432
 433        # Set up the mappings to track the remote branches.
 434        git config remote."$origin".fetch \
 435                "+refs/heads/*:$remote_top/*" '^$' &&
 436
 437        # Write out remote.$origin config, and update our "$head_points_at".
 438        case "$head_points_at" in
 439        ?*)
 440                # Local default branch
 441                git symbolic-ref HEAD "refs/heads/$head_points_at" &&
 442
 443                # Tracking branch for the primary branch at the remote.
 444                git update-ref HEAD "$head_sha1" &&
 445
 446                rm -f "refs/remotes/$origin/HEAD"
 447                git symbolic-ref "refs/remotes/$origin/HEAD" \
 448                        "refs/remotes/$origin/$head_points_at" &&
 449
 450                git config branch."$head_points_at".remote "$origin" &&
 451                git config branch."$head_points_at".merge "refs/heads/$head_points_at"
 452                ;;
 453        '')
 454                # Source had detached HEAD pointing nowhere
 455                git update-ref --no-deref HEAD "$head_sha1" &&
 456                rm -f "refs/remotes/$origin/HEAD"
 457                ;;
 458        esac
 459
 460        case "$no_checkout" in
 461        '')
 462                test "z$quiet" = z -a "z$no_progress" = z && v=-v || v=
 463                git read-tree -m -u $v HEAD HEAD
 464        esac
 465fi
 466rm -f "$GIT_DIR/CLONE_HEAD" "$GIT_DIR/REMOTE_HEAD"
 467
 468trap - 0